package com.ejie.ab79.dao;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;
import javax.sql.DataSource;

import org.springframework.dao.support.DataAccessUtils;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab79.comun.Constantes;
import com.ejie.ab79.model.RelEstIns;
import com.ejie.ab79.model.expedientes.DatosDirecciones;
import com.ejie.ab79.model.expedientes.DatosTerceros;
import com.ejie.ab79.model.expedientes.RelExpTer;
import com.ejie.ab79.model.expedientes.TiposTercero;
import com.ejie.ab79.model.inspecciones.Inspecciones;
import com.ejie.ab79.model.nora.T17Localidad;
import com.ejie.ab79.model.nora.T17Municipio;
import com.ejie.ab79.model.nora.T17Pais;
import com.ejie.ab79.model.nora.T17Provincia;
import com.ejie.ab79.model.procedimientos.Direcciones;
import com.ejie.ab79.model.procedimientos.Procedimientos;
import com.ejie.x38.dao.RowNumResultSetExtractor;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableManager;
import com.ejie.x38.dto.TableManagerJerarquia;
import com.ejie.x38.dto.TableRequestDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * RelEstInsDaoImpl  
 * 
 *  
 */

@Repository
@Transactional
public class RelEstInsDaoImpl implements RelEstInsDao {

	public static final String[] ORDER_BY_WHITE_LIST = new String[] { "IDRELESTINS", "IDINSPECCION", "IDTERCERO",
			"IDDIRECCION", "FOLDERID", "FECHAREGISTRO", "USUARIOREGISTRO" };

	private JdbcTemplate jdbcTemplate;

	/*
	 * ROW_MAPPERS
	 */
	private RowMapper<RelEstIns> rwMap = new RowMapper<RelEstIns>() {
		@Override
		public RelEstIns mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			RelEstIns relEstIns = new RelEstIns();
			relEstIns.setIdRelEstIns(resultSet.getInt("IDRELESTINS"));
			Inspecciones inspeccion = new Inspecciones();
			inspeccion.setIdInspeccion(resultSet.getInt("IDINSPECCION"));
			relEstIns.setInspeccionBD(inspeccion);
			relEstIns.setIdTercero(resultSet.getInt("IDTERCERO"));
			if (resultSet.wasNull()) {
				relEstIns.setIdTercero(null);
			}
			relEstIns.setIdDireccion(resultSet.getInt("IDDIRECCION"));
			if (resultSet.wasNull()) {
				relEstIns.setIdDireccion(null);
			}
			relEstIns.setTitulo(resultSet.getString("TITULO"));
			relEstIns.setFolderId(resultSet.getString("FOLDERID"));
			relEstIns.setUsuarioRegistro(resultSet.getString("USUARIOREGISTRO"));
			relEstIns.setIdentificadorEstablecimiento(resultSet.getString("IDENTEST"));

			Procedimientos procedimiento = new Procedimientos();
			procedimiento.setIdProcedimiento(resultSet.getInt("IDPROCEDIMIENTO"));
			if (resultSet.wasNull()) {
				procedimiento.setIdProcedimiento(null);
			}
			procedimiento.setCodProcedureId(resultSet.getString("CODPROCEDUREID"));
			procedimiento.setDescripcionEs(resultSet.getString("PROCEDIMIENTODESCES"));
			procedimiento.setDescripcionEu(resultSet.getString("PROCEDIMIENTODESCEU"));

			Direcciones direccion = new Direcciones();
			direccion.setIdDireccion(resultSet.getInt("IDDIRECCIONTURISMO"));
			procedimiento.setDirecciones(direccion);
			relEstIns.setProcedimiento(procedimiento);
			
			return relEstIns;

		}
	};

	private RowMapper<RelEstIns> rwMapPK = new RowMapper<RelEstIns>() {
		@Override
		public RelEstIns mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			return new RelEstIns(resultSet.getInt("IDRELESTINS"));
		}
	};

	/**
	 * Rowmapper para Jerarquía
	 *
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	private RowMapper<JerarquiaDto<RelEstIns>> rwMapJerarquia = new RowMapper<JerarquiaDto<RelEstIns>>() {
		@Override
		public JerarquiaDto<RelEstIns> mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			RelEstIns relEstIns = new RelEstIns();
			relEstIns.setIdRelEstIns(resultSet.getInt("IDRELESTINS"));
			Inspecciones inspeccion = new Inspecciones();
			inspeccion.setIdInspeccion(resultSet.getInt("IDINSPECCION"));
			relEstIns.setInspeccionBD(inspeccion);
			relEstIns.setIdTercero(resultSet.getInt("IDTERCERO"));
			if (resultSet.wasNull()) {
				relEstIns.setIdTercero(null);
			}
			relEstIns.setIdDireccion(resultSet.getInt("IDDIRECCION"));
			if (resultSet.wasNull()) {
				relEstIns.setIdDireccion(null);
			}
			relEstIns.setTitulo(resultSet.getString("TITULO"));
			relEstIns.setFolderId(resultSet.getString("FOLDERID"));
			relEstIns.setUsuarioRegistro(resultSet.getString("USUARIOREGISTRO"));

			JerarquiaDto<RelEstIns> jerarquia = new JerarquiaDto<RelEstIns>();
			jerarquia.setModel(relEstIns);
			jerarquia.setLevel(resultSet.getBigDecimal("LEVEL").intValue());
			jerarquia.setParentNodes(resultSet.getString("PARENTNODES"));
			jerarquia.setIsLeaf(Boolean.parseBoolean(resultSet.getString("ISLEAF")));
			jerarquia.setFilter(Boolean.parseBoolean(resultSet.getString("FILTER")));
			return jerarquia;
		}
	};

	private RowMapper<RelExpTer> rwMapParticipantes = new RowMapper<RelExpTer>() {
		@Override
		public RelExpTer mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			RelExpTer relExpTer = new RelExpTer();
			DatosTerceros datosTerceroAux = new DatosTerceros();
			TiposTercero tiposTerceroAux = new TiposTercero();
			tiposTerceroAux.setIdTipoTercero(resultSet.getLong("IDTIPOTERCERO"));
			tiposTerceroAux.setDescripcionCastellano(resultSet.getString("DESCRIPCIONCASTELLANO"));
			tiposTerceroAux.setDescripcionEuskera(resultSet.getString("DESCRIPCIONEUSKERA"));

			DatosDirecciones datosDirecciones = new DatosDirecciones();
			datosDirecciones.setIdDireccion(resultSet.getInt("IDDIRECCION"));
			if (resultSet.wasNull()) {
				datosDirecciones.setIdDireccion(null);
			}
			datosDirecciones.setDireccion(resultSet.getString("DIRECCION"));
			datosDirecciones.setCodigoPostal(resultSet.getString("CODIGOPOSTAL"));
			datosDirecciones.setNumero(resultSet.getString("NUMERO"));
			datosDirecciones.setEscalera(resultSet.getString("ESCALERA"));
			datosDirecciones.setPiso(resultSet.getString("PISO"));
			datosDirecciones.setLetra(resultSet.getString("LETRA"));
			datosDirecciones.setDescripcionCiudad(resultSet.getString("DESCRIPCIONCIUDAD"));
			datosDirecciones.setDescripcionProvincia(resultSet.getString("DESCRIPCIONPROVINCIA"));
			datosDirecciones.setComplementoDireccion(resultSet.getString("COMPLEMENTODIRECCION"));

			T17Pais pais = new T17Pais();
			pais.setId(resultSet.getString("IDPAIS"));
			T17Provincia provincia = new T17Provincia();
			provincia.setId(resultSet.getString("IDPROVINCIA"));
			T17Municipio municipio = new T17Municipio();
			municipio.setId(resultSet.getString("IDMUNICIPIO"));
			T17Localidad localidad = new T17Localidad();
			localidad.setId(resultSet.getString("IDLOCALIDAD"));

			datosDirecciones.setPais(pais);
			datosDirecciones.setProvincia(provincia);
			datosDirecciones.setMunicipio(municipio);
			datosDirecciones.setLocalidad(localidad);

			datosTerceroAux.setIdTercero(resultSet.getInt("DATOSTERCEROSIDTERCERO"));
			datosTerceroAux.setNombre(resultSet.getString("NOMBRE"));
			datosTerceroAux.setApellido1(resultSet.getString("APELLIDO1"));
			datosTerceroAux.setApellido2(resultSet.getString("APELLIDO2"));
			datosTerceroAux.setDocumento(resultSet.getString("DOCUMENTO"));
			datosTerceroAux.setTipoParticipante(resultSet.getInt("DATOSTERCEROSTIPOPARTICIPANTE"));
			datosTerceroAux.setDatoDireccion(datosDirecciones);
			relExpTer.setDatosTerceros(datosTerceroAux);
			relExpTer.setTiposTercero(tiposTerceroAux);
			relExpTer.setOrden(resultSet.getInt("ORDEN"));

			return relExpTer;
		}
	};

	/**
	 * Method use to set the datasource.
	 *
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	@Resource
	public void setDataSource(DataSource dataSource) {
		this.jdbcTemplate = new JdbcTemplate(dataSource);
	}

	/*
	 * OPERACIONES CRUD
	 */

	/**
	 * Inserts a single row in the RelEstIns table.
	 *
	 * @param relestins
	 *            RelEstIns
	 * @return RelEstIns
	 */
	@Override
	public RelEstIns add(RelEstIns relestins) {

		Integer idProcedimientoAux = null;
		if (relestins.getProcedimiento() != null && relestins.getProcedimiento().getIdProcedimiento() != null) {
			idProcedimientoAux = relestins.getProcedimiento().getIdProcedimiento();
		}
		
		int idRelEstIns = this.jdbcTemplate.queryForObject("SELECT AB79.S_AB7922T00.NEXTVAL FROM DUAL", Integer.class);
		relestins.setIdRelEstIns(idRelEstIns);

		String query = "INSERT INTO REL_EST_INS (ID_REL_EST_INS, ID_INSPECCION, ID_TERCERO, ID_DIRECCION, TITULO, FOLDER_ID, FECHA_REGISTRO, USUARIO_REGISTRO, ID_EXPEDIENTE_ORIGEN, ID_PROCEDIMIENTO) VALUES (?,?,?,?,?,?,sysdate,?,?,?)";
		this.jdbcTemplate.update(query, relestins.getIdRelEstIns(),
				relestins.getInspeccionBD() != null ? relestins.getInspeccionBD().getIdInspeccion() : null,
				relestins.getIdTercero(), relestins.getIdDireccion(), relestins.getTitulo(), relestins.getFolderId(),
				relestins.getUsuarioRegistro(), relestins.getIdExpedienteOrigen(), idProcedimientoAux);
		return relestins;
	}

	/**
	 * Updates a single row in the RelEstIns table.
	 *
	 * @param relestins
	 *            RelEstIns
	 * @return RelEstIns
	 */
	@Override
	public RelEstIns update(RelEstIns relestins) {

		Integer idProcedimientoAux = null;
		if (relestins.getProcedimiento().getIdProcedimiento() != null) {
			idProcedimientoAux = relestins.getProcedimiento().getIdProcedimiento();
		}
		
		String query = "UPDATE REL_EST_INS SET ID_INSPECCION=?, ID_TERCERO=?, ID_DIRECCION=?, TITULO=?, FOLDER_ID=?, FECHA_ULTMODIFICACION=SYSDATE, USUARIO_ULTMODIFICACION=?, ID_PROCEDIMIENTO=? WHERE ID_REL_EST_INS=?";
		this.jdbcTemplate.update(query,
				relestins.getInspeccionBD() != null ? relestins.getInspeccionBD().getIdInspeccion() : null,
				relestins.getIdTercero(), relestins.getIdDireccion(), relestins.getTitulo(), relestins.getFolderId(),
				relestins.getUsuarioUltModificacion(), idProcedimientoAux, relestins.getIdRelEstIns());
		return relestins;
	}

	@Override
	@Transactional(readOnly = true)
	public RelEstIns find(RelEstIns relestins) {
		String query = "SELECT t1.ID_REL_EST_INS IDRELESTINS, t1.ID_INSPECCION IDINSPECCION, t1.ID_TERCERO IDTERCERO, t1.ID_DIRECCION IDDIRECCION, t1.TITULO TITULO, t1.FOLDER_ID FOLDERID, "
				+ " t1.FECHA_REGISTRO FECHAREGISTRO, t1.USUARIO_REGISTRO USUARIOREGISTRO, "
				+ " t2.ID_PROCEDIMIENTO IDPROCEDIMIENTO, t2.COD_PROCEDURE_ID CODPROCEDUREID, t2.DESCRIPCION_CASTELLANO PROCEDIMIENTODESCES, t2.DESCRIPCION_EUSKERA PROCEDIMIENTODESCEU, "
				+ " t2.ID_DIRECCION IDDIRECCIONTURISMO "
				+ " FROM REL_EST_INS t1, PROCEDIMIENTOS t2 "
				+ " WHERE t1.ID_REL_EST_INS = ? AND t1.ID_PROCEDIMIENTO = t2.ID_PROCEDIMIENTO(+) ";

		List<RelEstIns> relestinsList = this.jdbcTemplate.query(query, this.rwMap, relestins.getIdRelEstIns());
		return DataAccessUtils.uniqueResult(relestinsList);
	}

	@Override
	public RelEstIns findByInspeccion(Inspecciones inspecciones) {
		String query = "SELECT t1.ID_REL_EST_INS IDRELESTINS, t1.ID_INSPECCION IDINSPECCION, t1.ID_TERCERO IDTERCERO, t1.ID_DIRECCION IDDIRECCION, "
				+ " t1.TITULO TITULO, t1.FOLDER_ID FOLDERID, t1.FECHA_REGISTRO FECHAREGISTRO, t1.USUARIO_REGISTRO USUARIOREGISTRO, "
				+ " t2.ID_PROCEDIMIENTO IDPROCEDIMIENTO, t2.COD_PROCEDURE_ID CODPROCEDUREID, t2.DESCRIPCION_CASTELLANO PROCEDIMIENTODESCES, t2.DESCRIPCION_EUSKERA PROCEDIMIENTODESCEU, "
				+ " t2.ID_DIRECCION IDDIRECCIONTURISMO, ( SELECT IDENTIFICADOR_ESTABLECIMIENTO FROM DATOS_DIRECCIONES t3 WHERE t1.ID_DIRECCION = t3.ID_DIRECCION AND t3.ID_TIPO_DIRECCION = 2 ) IDENTEST "
				+ " FROM REL_EST_INS t1, PROCEDIMIENTOS t2 "
				+ " WHERE t1.ID_INSPECCION = ?  AND t1.ID_PROCEDIMIENTO = t2.ID_PROCEDIMIENTO(+) ";

		List<RelEstIns> relestinsList = this.jdbcTemplate.query(query, this.rwMap, inspecciones.getIdInspeccion());
		return DataAccessUtils.uniqueResult(relestinsList);
	}

	/**
	 * Removes a single row in the RelEstIns table.
	 *
	 * @param relestins
	 *            RelEstIns
	 * @return
	 */
	@Override
	public void remove(RelEstIns relestins) {
		String query = "DELETE FROM REL_EST_INS WHERE ID_REL_EST_INS=?";
		this.jdbcTemplate.update(query, relestins.getIdRelEstIns());
	}

	@Override
	public void removeByInspeccion(Inspecciones inspeccion) {
		String query = "DELETE FROM REL_EST_INS WHERE ID_INSPECCION=?";
		this.jdbcTemplate.update(query, inspeccion.getIdInspeccion());
	}

	@Override
	public void eliminarTercero(DatosTerceros datosTercero) {
		String query = "UPDATE REL_EST_INS SET ID_TERCERO = NULL WHERE ID_TERCERO = ?";
		this.jdbcTemplate.update(query, datosTercero.getIdTercero());
	}

	@Override
	public List<RelExpTer> findParticipantes(Integer idInspeccion) {
		StringBuilder query = new StringBuilder();

		query.append("SELECT " + Constantes.PARTICIPACION_AFECTADO + " AS IDTIPOTERCERO");
		query.append(", '" + Constantes.AFECTADO_CAS + "' AS DESCRIPCIONCASTELLANO, '" + Constantes.AFECTADO_EUS
				+ "' AS DESCRIPCIONEUSKERA");
		query.append(", t7922.ID_TERCERO AS DATOSTERCEROSIDTERCERO");
		query.append(", t6135.NOMBRE AS NOMBRE, t6135.APELLIDO1 AS APELLIDO1, t6135.APELLIDO2 AS APELLIDO2");
		query.append(", t6135.TIPO_PARTICIPANTE AS DATOSTERCEROSTIPOPARTICIPANTE, t6135.DOCUMENTO AS DOCUMENTO");
		// Tipo de Tercero:
		// 1: Solicitante
		// 3: Afectado
		// 6: Representante Legal
		// 2: Persona de Contacto
		// 7: Denunciado Provisional
		query.append(", 1 AS ORDEN");
		query.append(", t6136.ID_DIRECCION IDDIRECCION, t6136.ID_PAIS IDPAIS, t6136.ID_PROVINCIA IDPROVINCIA");
		query.append(", t6136.ID_MUNICIPIO IDMUNICIPIO, t6136.ID_LOCALIDAD IDLOCALIDAD, t6136.DIRECCION DIRECCION");
		query.append(
				", t6136.NUMERO NUMERO, t6136.ESCALERA ESCALERA, t6136.PISO PISO, t6136.LETRA LETRA, t6136.CODIGO_POSTAL CODIGOPOSTAL, t6136.COMPLEMENTO_DIRECCION COMPLEMENTODIRECCION");
		query.append(", t6136.DESCRIPCION_CIUDAD DESCRIPCIONCIUDAD, t6136.DESCRIPCION_PROVINCIA DESCRIPCIONPROVINCIA");
		query.append(" FROM REL_EST_INS t7922");
		query.append(" LEFT OUTER JOIN DATOS_TERCEROS t6135 ON t7922.ID_TERCERO = t6135.ID_TERCERO");
		query.append(
				" LEFT OUTER JOIN DATOS_DIRECCIONES t6136 ON t6135.ID_TERCERO = t6136.ID_TERCERO AND t6136.ID_TIPO_DIRECCION = "
						+ Constantes.ID_DIRECCION_POSTAL);
		query.append(" WHERE t7922.ID_INSPECCION = ?");
		query.append(" ORDER BY ORDEN, DATOSTERCEROSTIPOPARTICIPANTE ASC");

		return this.jdbcTemplate.query(query.toString(), this.rwMapParticipantes, idInspeccion);
	}

	/**
	 * Exporta Datos al clipBoard
	 *
	 */
	@Override
	public List<RelEstIns> getMultiple(RelEstIns filterRelEstIns, TableRequestDto tableRequestDto, Boolean startsWith) {

		// Where clause & Params
		Map<String, Object> mapaWhere = this.getWhereLikeMap(filterRelEstIns, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));

		@SuppressWarnings("unchecked")
		List<Object> params = (List<Object>) mapaWhere.get("params");

		StringBuilder sbMultipleSQL = TableManager.getSelectMultipleQuery(tableRequestDto, RelEstIns.class, params,
				"ID_REL_EST_INS");

		return this.jdbcTemplate.query(sbMultipleSQL.toString(), this.rwMap, params.toArray());
	}

	/**
	 * Finds a list of rows in the RelEstIns table.
	 *
	 * @param relestins
	 *            RelEstIns
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<RelEstIns>
	 */
	@Override
	@Transactional(readOnly = true)
	public List<RelEstIns> findAll(RelEstIns relestins, TableRequestDto tableRequestDto) {

		StringBuilder query = new StringBuilder(
				"SELECT  t1.ID_REL_EST_INS IDRELESTINS,t1.ID_INSPECCION IDINSPECCION,t1.ID_TERCERO IDTERCERO,t1.ID_DIRECCION IDDIRECCION,t1.TITULO TITULO,"
				+ " t1.FOLDER_ID FOLDERID,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO, "
				+ " t2.ID_PROCEDIMIENTO IDPROCEDIMIENTO, t2.COD_PROCEDURE_ID CODPROCEDUREID, t2.DESCRIPCION_CASTELLANO PROCEDIMIENTODESCES, "
				+ " t2.DESCRIPCION_EUSKERA PROCEDIMIENTODESCEU, t2.ID_DIRECCION IDDIRECCIONTURISMO, ");
		query.append(
				" (SELECT IDENTIFICADOR_ESTABLECIMIENTO FROM DATOS_DIRECCIONES t3 WHERE t1.ID_DIRECCION = t3.ID_DIRECCION AND t3.ID_TIPO_DIRECCION = 2 ) IDENTEST");
		query.append(" FROM REL_EST_INS t1, PROCEDIMIENTOS t2  ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(relestins);
		StringBuilder where = new StringBuilder(" WHERE 1=1  AND t1.ID_PROCEDIMIENTO = t2.ID_PROCEDIMIENTO(+) ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		if (tableRequestDto != null) {
			query = TableManager.getPaginationQuery(tableRequestDto, query, RelEstInsDaoImpl.ORDER_BY_WHITE_LIST);
		}

		return this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}

	/**
	 * Finds rows in the RelEstIns table using like.
	 *
	 * @param relestins
	 *            RelEstIns
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<RelEstIns>
	 */
	@Override
	@Transactional(readOnly = true)
	public List<RelEstIns> findAllLike(RelEstIns relestins, TableRequestDto tableRequestDto, Boolean startsWith) {
		StringBuilder query = new StringBuilder(
				"SELECT  t1.ID_REL_EST_INS IDRELESTINS,t1.ID_INSPECCION IDINSPECCION,t1.ID_TERCERO IDTERCERO,t1.ID_DIRECCION IDDIRECCION,t1.TITULO TITULO,"
				+ " t1.FOLDER_ID FOLDERID,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO, "
				+ " t2.ID_PROCEDIMIENTO IDPROCEDIMIENTO, t2.COD_PROCEDURE_ID CODPROCEDUREID, t2.DESCRIPCION_CASTELLANO PROCEDIMIENTODESCES, "
				+ " t2.DESCRIPCION_EUSKERA PROCEDIMIENTODESCEU, t2.ID_DIRECCION IDDIRECCIONTURISMO  ");
		query.append("FROM REL_EST_INS t1, t2.PROCEDIMIENTOS ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(relestins, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 AND t1.ID_PROCEDIMIENTO = t2.ID_PROCEDIMIENTO(+) ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		if (tableRequestDto != null) {
			query = TableManager.getPaginationQuery(tableRequestDto, query, RelEstInsDaoImpl.ORDER_BY_WHITE_LIST);
		}

		return this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}

	@Override
	@Transactional(readOnly = true)
	public Long findAllCount(RelEstIns relestins) {
		StringBuilder query = new StringBuilder("SELECT COUNT(1) FROM REL_EST_INS t1, t2.PROCEDIMIENTOS  ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(relestins);
		StringBuilder where = new StringBuilder(" WHERE 1=1 AND t1.ID_PROCEDIMIENTO = t2.ID_PROCEDIMIENTO(+) ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	@Override
	@Transactional(readOnly = true)
	public Long findAllLikeCount(RelEstIns relestins, Boolean startsWith) {
		StringBuilder query = new StringBuilder("SELECT COUNT(1) FROM REL_EST_INS t1, t2.PROCEDIMIENTOS  ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(relestins, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 AND t1.ID_PROCEDIMIENTO = t2.ID_PROCEDIMIENTO(+) ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Reorder the data list of RelEstIns selected for rup_table
	 *
	 * @param relestins
	 *            RelEstIns
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<RelEstIns>>
	 */
	@Override
	public List<TableRowDto<RelEstIns>> reorderSelection(RelEstIns relestins, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_REL_EST_INS IDRELESTINS,t1.ID_INSPECCION IDINSPECCION,t1.ID_TERCERO IDTERCERO,t1.ID_DIRECCION IDDIRECCION,t1.TITULO TITULO,t1.FOLDER_ID FOLDERID,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		// FROM
		query.append("FROM REL_EST_INS t1 ");
		// FILTRADO
		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(relestins, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		// Parámetros de filtrado
		@SuppressWarnings("unchecked")
		List<Object> filterParamList = (List<Object>) mapaWhere.get("params");

		// SQL para la reordenación
		StringBuilder sbReorderSelectionSQL = TableManager.getReorderQuery(query, tableRequestDto, RelEstIns.class,
				filterParamList, "ID_REL_EST_INS");

		return this.jdbcTemplate.query(sbReorderSelectionSQL.toString(),
				new RowNumResultSetExtractor<RelEstIns>(this.rwMapPK, tableRequestDto), filterParamList.toArray());
	}

	/**
	 * Search method for rup_table
	 *
	 * @param filterParams
	 *            RelEstIns
	 * @param searchParams
	 *            RelEstIns
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<RelEstIns>>
	 */
	@Override
	public List<TableRowDto<RelEstIns>> search(RelEstIns filterParams, RelEstIns searchParams,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_REL_EST_INS IDRELESTINS,t1.ID_INSPECCION IDINSPECCION,t1.ID_TERCERO IDTERCERO,t1.ID_DIRECCION IDDIRECCION,t1.TITULO TITULO,t1.FOLDER_ID FOLDERID,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		// FROM
		query.append("FROM REL_EST_INS t1 ");
		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// FILTRADO
		Map<String, ?> mapaWhereFilter = this.getWhereLikeMap(filterParams, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhereFilter.get("query"));
		query.append(where);
		// Filter params
		@SuppressWarnings("unchecked")
		List<Object> filterParamList = (List<Object>) mapaWhereFilter.get("params");

		// BUSQUEDA
		Map<String, Object> mapaWhereSearch = this.getWhereLikeMap(searchParams, startsWith);
		String searchSQL = ((StringBuilder) mapaWhereSearch.get("query")).toString();
		// Search params
		@SuppressWarnings("unchecked")
		List<Object> searchParamList = (List<Object>) mapaWhereSearch.get("params");

		// SQL
		StringBuilder sbReorderSelectionSQL = TableManager.getSearchQuery(query, tableRequestDto, RelEstIns.class,
				filterParamList, searchSQL, searchParamList, from_alias, "ID_REL_EST_INS");

		return this.jdbcTemplate.query(sbReorderSelectionSQL.toString(),
				new RowNumResultSetExtractor<RelEstIns>(this.rwMapPK, tableRequestDto), filterParamList.toArray());
	}

	/**
	 * Remove multiple method for rup_table
	 *
	 * @param filterrelestins
	 *            RelEstIns
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	@Override
	public void removeMultiple(RelEstIns filterrelestins, TableRequestDto tableRequestDto, Boolean startsWith) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_REL_EST_INS IDRELESTINS,t1.ID_INSPECCION IDINSPECCION,t1.ID_TERCERO IDTERCERO,t1.ID_DIRECCION IDDIRECCION,t1.TITULO TITULO,t1.FOLDER_ID FOLDERID,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		// FROM
		query.append("FROM REL_EST_INS t1 ");

		// WHERE
		Map<String, Object> mapaWhere = this.getWhereLikeMap(filterrelestins, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		@SuppressWarnings("unchecked")
		List<Object> params = (List<Object>) mapaWhere.get("params");

		StringBuilder sbRemoveMultipleSQL = TableManager.getRemoveMultipleQuery(tableRequestDto, RelEstIns.class, query,
				params, "ID_REL_EST_INS");
		this.jdbcTemplate.update(sbRemoveMultipleSQL.toString(), params.toArray());
	}

	/**
	 * Filter in the hierarchical RelEstIns table.
	 *
	 * @param filterRelEstIns
	 *            RelEstIns
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<JerarquiaDto<RelEstIns>>
	 */
	@Override
	public List<JerarquiaDto<RelEstIns>> findAllLikeJerarquia(RelEstIns filterRelEstIns,
			TableRequestDto tableRequestDto) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_REL_EST_INS IDRELESTINS,t1.ID_INSPECCION IDINSPECCION,t1.ID_TERCERO IDTERCERO,t1.ID_DIRECCION IDDIRECCION,t1.TITULO TITULO,t1.FOLDER_ID FOLDERID,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		// FROM
		// StringBuilder from = new StringBuilder("FROM REL_EST_INS t1 ");
		List<String> from = new ArrayList<String>();
		from.add("REL_EST_INS");
		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterRelEstIns, false);

		// JERARQUIA
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		query = TableManagerJerarquia.getQuery(tableRequestDto, query, mapaWhere, "ID_REL_EST_INS", "ID_PADRE",
				"NOMBRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// query = TableManagerJerarquia.getQuery(tableRequestDto, query,
		// mapaWhere, "ID", "ID_PADRE", "NOMBRE", from, from_alias, joins,
		// businessFilters, businessParams);

		// PAGINACION
		if (tableRequestDto != null) {
			query = TableManagerJerarquia.getPaginationQuery(tableRequestDto, query,
					RelEstInsDaoImpl.ORDER_BY_WHITE_LIST);
		}

		List<?> params = (List<?>) mapaWhere.get("params");
		return this.jdbcTemplate.query(query.toString(), this.rwMapJerarquia, params.toArray());
	}

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterRelEstIns
	 *            RelEstIns
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return Long
	 */
	@Override
	public Long findAllLikeCountJerarquia(RelEstIns filterRelEstIns, TableRequestDto tableRequestDto) {
		// FROM
		// StringBuilder from = new StringBuilder("FROM REL_EST_INS t1 ");
		List<String> from = new ArrayList<String>();
		from.add("REL_EST_INS");

		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterRelEstIns, false);

		// JERARQUIA
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		StringBuilder query = TableManagerJerarquia.getQueryCount(tableRequestDto, mapaWhere, "ID_REL_EST_INS",
				"ID_PADRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// StringBuilder query =
		// TableManagerJerarquia.getQueryCount(tableRequestDto, mapaWhere, "ID",
		// "ID_PADRE", from, from_alias, joins, businessFilters,
		// businessParams);

		List<?> params = (List<?>) mapaWhere.get("params");
		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterRelEstIns
	 *            RelEstIns
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<TableRowDto<RelEstIns>>
	 */
	@Override
	public List<TableRowDto<RelEstIns>> findAllChild(RelEstIns filterRelEstIns, TableRequestDto tableRequestDto) {

		// FROM
		// StringBuilder from = new StringBuilder("FROM REL_EST_INS t1 ");
		List<String> from = new ArrayList<String>();
		from.add("REL_EST_INS");

		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterRelEstIns, false);

		// MULTISELECCION
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		StringBuilder query = TableManagerJerarquia.getQueryChildren(tableRequestDto, mapaWhere, "ID_REL_EST_INS",
				"ID_PADRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// StringBuilder query =
		// TableManagerJerarquia.getQueryChildren(tableRequestDto, mapaWhere,
		// "ID", "ID_PADRE", from, from_alias, joins, businessFilters,
		// businessParams);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.query(query.toString(),
				new RowNumResultSetExtractor<RelEstIns>(this.rwMapPK, "ID_REL_EST_INS"), params.toArray());
	}

	/*
	 * MÉTODOS PRIVADOS
	 */

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the RelEstIns entity
	 *
	 * @param relestins
	 *            RelEstIns Bean with the criteria values to filter by.
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	// CHECKSTYLE:OFF CyclomaticComplexity - Generación de código de UDA
	private Map<String, ?> getWhereMap(RelEstIns relestins) {

		StringBuilder where = new StringBuilder(RelEstInsDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (relestins != null && relestins.getIdRelEstIns() != null) {
			where.append(" AND t1.ID_REL_EST_INS = ?");
			params.add(relestins.getIdRelEstIns());
		}
		if (relestins != null && relestins.getInspeccionBD() != null
				&& relestins.getInspeccionBD().getIdInspeccion() != null) {
			where.append(" AND t1.ID_INSPECCION = ?");
			params.add(relestins.getInspeccionBD().getIdInspeccion());
		}
		if (relestins != null && relestins.getIdTercero() != null) {
			where.append(" AND t1.ID_TERCERO = ?");
			params.add(relestins.getIdTercero());
		}
		if (relestins != null && relestins.getIdDireccion() != null) {
			where.append(" AND t1.ID_DIRECCION = ?");
			params.add(relestins.getIdDireccion());
		}
		if (relestins != null && relestins.getTitulo() != null) {
			where.append(" AND t1.TITULO = ?");
			params.add(relestins.getTitulo());
		}
		if (relestins != null && relestins.getFolderId() != null) {
			where.append(" AND t1.FOLDER_ID = ?");
			params.add(relestins.getFolderId());
		}
		if (relestins != null && relestins.getUsuarioRegistro() != null) {
			where.append(" AND t1.USUARIO_REGISTRO = ?");
			params.add(relestins.getUsuarioRegistro());
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}
	// CHECKSTYLE:ON CyclomaticComplexity - Generación de código de UDA

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the RelEstIns entity
	 *
	 * @param relestins
	 *            RelEstIns Bean with the criteria values to filter by.
	 * @param startsWith
	 *            Boolean
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	// CHECKSTYLE:OFF CyclomaticComplexity - Generación de código de UDA
	private Map<String, Object> getWhereLikeMap(RelEstIns relestins, Boolean startsWith) {

		StringBuilder where = new StringBuilder(RelEstInsDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (relestins != null && relestins.getIdRelEstIns() != null) {
			where.append(" AND t1.ID_REL_EST_INS = ?");
			params.add(relestins.getIdRelEstIns());
		}
		if (relestins != null && relestins.getInspeccionBD() != null
				&& relestins.getInspeccionBD().getIdInspeccion() != null) {
			where.append(" AND t1.ID_INSPECCION = ?");
			params.add(relestins.getInspeccionBD().getIdInspeccion());
		}
		if (relestins != null && relestins.getIdTercero() != null) {
			where.append(" AND t1.ID_TERCERO = ?");
			params.add(relestins.getIdTercero());
		}
		if (relestins != null && relestins.getIdDireccion() != null) {
			where.append(" AND t1.ID_DIRECCION = ?");
			params.add(relestins.getIdDireccion());
		}
		if (relestins != null && relestins.getTitulo() != null) {
			where.append(" AND UPPER(t1.TITULO) like ? ESCAPE '\\'");
			if (startsWith) {
				params.add(relestins.getTitulo().toUpperCase() + "%");
			} else {
				params.add("%" + relestins.getTitulo().toUpperCase() + "%");
			}
		}
		if (relestins != null && relestins.getFolderId() != null) {
			where.append(" AND UPPER(t1.FOLDER_ID) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(relestins.getFolderId().toUpperCase() + "%");
			} else {
				params.add("%" + relestins.getFolderId().toUpperCase() + "%");
			}
			where.append(" AND t1.FOLDER_ID IS NOT NULL");
		}
		if (relestins != null && relestins.getUsuarioRegistro() != null) {
			where.append(" AND UPPER(t1.USUARIO_REGISTRO) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(relestins.getUsuarioRegistro().toUpperCase() + "%");
			} else {
				params.add("%" + relestins.getUsuarioRegistro().toUpperCase() + "%");
			}
			where.append(" AND t1.USUARIO_REGISTRO IS NOT NULL");
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}
	// CHECKSTYLE:ON CyclomaticComplexity - Generación de código de UDA

	/**
	 * StringBuilder initilization value
	 */
	public static final int STRING_BUILDER_INIT = 4096;

	@Override
	public void actualizarTituloInspeccion(RelEstIns relEstIns) {
		String query = "UPDATE REL_EST_INS SET TITULO = ?, FECHA_ULTMODIFICACION = SYSDATE, USUARIO_ULTMODIFICACION = ? WHERE ID_INSPECCION = ?";
		this.jdbcTemplate.update(query, relEstIns.getTitulo(), relEstIns.getUsuarioUltModificacion(),
				relEstIns.getInspeccion().getIdInspeccion());
	}

}
